<?php

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

function eme_meta_box_div_event_task_signup_approved_email($event,$templates_array) {
?>
<div>
   <b><?php _e('Task Signup Made Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email sent to the respondent when that person signs up for a task (not pending) or approved.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_email_subject_tpl'],'eme_prop_task_signup_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Task Signup Made Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email sent to the respondent when that person signs up for a task (not pending) or approved.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_email_body_tpl'],'eme_prop_task_signup_email_body_tpl',$templates_array); ?>
</div>
<br />
<div>
   <b><?php _e('Contact Person Task Signup Made Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email which will be sent to the contact person when someone signs up for a task.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['cp_task_signup_email_subject_tpl'],'eme_prop_cp_task_signup_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Contact Person Task Signup Made Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email which will be sent to the contact person when someone signs up for a task.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['cp_task_signup_email_body_tpl'],'eme_prop_cp_task_signup_email_body_tpl',$templates_array); ?>
</div>
<?php
}

function eme_meta_box_div_event_task_signup_pending_email($event,$templates_array) {
?>
<div>
   <b><?php _e('Task Signup Pending Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email which will be sent to the respondent if the task signup requires approval.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_pending_email_subject_tpl'],'eme_prop_task_signup_pending_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Task Signup Pending Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email which will be sent to the respondent if the task signup requires approval.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_pending_email_body_tpl'],'eme_prop_task_signup_pending_email_body_tpl',$templates_array); ?>
</div>
<br />
<div>
   <b><?php _e('Contact Person Task Signup Pending Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email which will be sent to the contact person if a task signup requires approval.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['cp_task_signup_pending_email_subject_tpl'],'eme_prop_cp_task_signup_pending_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Contact Person Task Signup Pending Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email which will be sent to the contact person if a task signup requires approval.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['cp_task_signup_pending_email_body_tpl'],'eme_prop_cp_task_signup_pending_email_body_tpl',$templates_array); ?>
</div>
<?php
}

function eme_meta_box_div_event_task_signup_updated_email($event,$templates_array) {
?>
<div>
   <b><?php _e('Task Signup Updated Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email which will be sent to the respondent if the task signup has been updated by an admin.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_updated_email_subject_tpl'],'eme_prop_task_signup_updated_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Task Signup Updated Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email which will be sent to the respondent if the task signup has been updated by an admin.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_updated_email_body_tpl'],'eme_prop_task_signup_updated_email_body_tpl',$templates_array); ?>
</div>
<?php
}

function eme_meta_box_div_event_task_signup_cancelled_email($event,$templates_array) {
?>
<div>
   <b><?php _e('Task Signup Cancelled Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email which will be sent to the respondent when he himself cancels a task signup.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_cancelled_email_subject_tpl'],'eme_prop_task_signup_cancelled_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Task Signup Cancelled Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email which will be sent to the respondent when he himself cancels a task signup.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_cancelled_email_body_tpl'],'eme_prop_task_signup_cancelled_email_body_tpl',$templates_array); ?>
</div>
<br />
<div>
   <b><?php _e('Contact Person Task Signup Cancelled Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email which will be sent to the contact person when a respondent cancels a task signup.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['cp_task_signup_cancelled_email_subject_tpl'],'eme_prop_cp_task_signup_cancelled_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Contact Person Task Signup Cancelled Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email which will be sent to the contact person when a respondent cancels a task signup.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['cp_task_signup_cancelled_email_body_tpl'],'eme_prop_cp_task_signup_cancelled_email_body_tpl',$templates_array); ?>
</div>
<?php
}

function eme_meta_box_div_event_task_signup_trashed_email($event,$templates_array) {
?>
<div id="div_event_registration_trashed_email">
   <b><?php _e('Task Signup Deleted Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email which will be sent to the respondent if the task signup is deleted by an admin.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_trashed_email_subject_tpl'],'eme_prop_task_signup_trashed_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Task Signup Deleted Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email which will be sent to the respondent if the task signup is deleted by an admin.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_trashed_email_body_tpl'],'eme_prop_task_signup_trashed_email_body_tpl',$templates_array); ?>
</div>
<?php
}

function eme_meta_box_div_event_task_signup_form_format($event,$templates_array) {
?>
<div id="div_event_task_signup_form_format">
   <b><?php _e('Task Signup Form', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The layout of the task signup form.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy');?>
   <?php echo eme_ui_select($event['event_properties']['task_signup_form_format_tpl'],'eme_prop_task_signup_form_format_tpl',$templates_array); ?>
</div>
<?php
}

function eme_meta_box_div_event_task_signup_recorded_ok_html($event,$templates_array) {
?>
<div id="div_event_task_signup_recorded_ok_html">
   <b><?php _e('Signup recorded message', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The text (html allowed) shown to the user when the task signup has been made successfully.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy');?>
   <?php echo eme_ui_select($event['event_properties']['task_signup_recorded_ok_html_tpl'],'eme_prop_task_signup_recorded_ok_html_tpl',$templates_array); ?>
</div>
<?php
}

function eme_meta_box_div_event_tasks($event) {
}

?>
